<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <div
            class="w-full bg-neutral text-white flex justify-between items-center py-3"
        >
            <div class="w-12 cursor-pointer pl-4">
                <font-awesome-icon
                    icon="fa-solid fa-arrow-left"
                    size="2x"
                    @click="$router.go(-1)"
                />
            </div>
            <div class="flex-1 text-center">
                <a
                    href="javascript:"
                    class="cursor-pointer"
                    @click="$router.push({name: 'user.home'})"
                >
                    <img
                        :src="'/img/logo.png'"
                        class="h-12 mx-auto text-center"
                    />
                </a>
            </div>
            <div class="w-12" />
        </div>
        <div
            class="mb-20"
        >
            <img
                :src="plan.featured_photo"
                class="aspect-video object-cover"
            />
        </div>
        <template
            v-if="plan"
        >
            <div
                class="mx-8 my-6 flex flex-col space-y-2 -mt-36"
            >
                <div
                    class="w-full shadow-lg rounded-xl bg-white shadow-lg shadow-gray-300 px-2 py-4"
                >
                    <div
                        class="flex justify-start space-x-2 border-b border-gray-300 pb-6 mb-6"
                    >
                        <div
                            class="w-12 text-center"
                        >
                            <img
                                :src="plan.category_icon"
                                class="w-full"
                            />
                        </div>
                        <div
                            class="flex-1"
                        >
                            <div>
                                <div class="font-black leading-tight text-lg">{{ plan.plan_name }}</div>
                                <div class="font-bold leading-tight text-xs mb-2">({{ plan.code }})</div>
                            </div>
                            <div
                                class="flex justify-between capitalize items-center"
                            >
                                <div
                                    class="flex-1 flex justify-start space-x-3 items-center"
                                >
                                    <div>
                                        {{ $t(`plan_${plan.setting.plan_type}_category`)}}
                                    </div>
                                    <div>
                                        <font-awesome-icon
                                            icon="fa-regular fa-question-circle cursor-pointer"
                                        />
                                    </div>
                                </div>
                                <a
                                    href="javascript:"
                                    class="rounded-full w-8 h-8 bg-sky-200 text-blue-700 text-center flex justify-center items-center share-btn"
                                    @click="sharePlan"
                                >
                                    <font-awesome-icon
                                        icon="fa-solid fa-share-nodes"
                                        size="1x"
                                    />
                                </a>
                            </div>
                        </div>
                    </div>
                    <div
                        class="flex justify-between"
                    >
                        <div
                            class="flex-1 font-black flex justify-start items-center text-xl"
                        >
                            <span
                                v-if="plan.return_percentage_from > 0"
                                class="text-green-500 text-2xl "
                            >
                                +{{ plan.return_percentage_from }}%
                            </span>
                            <span
                                v-else-if="plan.return_percentage_from < 0"
                                class="text-red-600 text-2xl font-black"
                            >
                                {{ plan.return_percentage_from }}%
                            </span>
                            <span
                                class="px-2"
                            >
                                to
                            </span>
                            <span
                                v-if="plan.return_percentage_to > 0"
                                class="text-green-500 text-2xl "
                            >
                                +{{ plan.return_percentage_to }}%
                            </span>
                            <span
                                v-else-if="plan.return_percentage_to < 0"
                                class="text-red-600 text-2xl font-black"
                            >
                                {{ plan.return_percentage_to }}%
                            </span>
                        </div>
                        <div>
                            <div
                                class="bg-red-500 text-white font-bold text-xs px-4 py-1.5"
                            >
                                {{ plan.return_cycle }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="flex flex-col flex-start divide-y divide-gray-300"
            >
                <div
                    class="flex justify-start space-x-2 px-3 py-4 items-center"
                >
                    <div>
                        <img
                            :src="'/img/contract-period.png'"
                            class="w-7 h-7"
                        />
                    </div>
                    <div
                        class="capitalize"
                    >
                        {{ $t('contract') }}: {{ plan.setting.capital_lock_days }} {{ $t('days') }}
                    </div>
                </div>
                <div
                    class="flex justify-start space-x-2 px-3 py-4 items-center"
                >
                    <div>
                        <img
                            :src="'/img/minimum-buy-in.png'"
                            class="w-7 h-7"
                        />
                    </div>
                    <div
                        class="capitalize"
                    >
                        {{ $t('minimum_buy_in') }}: ${{ $helper.fundFormat(plan.setting.initial_investment_amount, 0) }}
                    </div>
                </div>
                <div
                    class="flex justify-start space-x-2 px-3 py-4 items-center"
                >
                    <div>
                        <img
                            :src="'/img/fund-size.png'"
                            class="w-7 h-7"
                        />
                    </div>
                    <div
                        class="capitalize"
                    >
                        {{ $t('fund_size') }}: ${{ $helper.fundFormat(plan.fund_size, 0) }}
                    </div>
                </div>
                <div
                    class="px-3 py-4"
                >
                    <div
                        class="font-black text-lg mb-2"
                    >
                        {{ $t('about_this_fund') }}
                    </div>
                    <div
                        class="content-container"
                        v-html="$helper.editorJsParser(plan.fund_description)"
                    />
                </div>
                <div
                    class="p-4"
                >
                    <auto-button
                        :block="true"
                        rounded
                        class="tracking-wider text-2xl"
                        @click="$router.push({name: 'user.explore.plan_invest', params: {code: plan.code}})"
                    >
                        {{ $t('buy_in') }}
                    </auto-button>
                </div>
            </div>
        </template>
    </div>
</template>

<script setup>
import {computed, ref} from "vue";
import {FontAwesomeIcon} from "@fortawesome/vue-fontawesome";
import {useSettingStore} from "~/stores/setting.js";
import {useRoute, useRouter} from "vue-router";
import AutoButton from "!/admin/components/button/auto-button.vue";

const pageReady = ref(true);
const $route = useRoute();
const $router = useRouter();
const $settingStore = useSettingStore();

const plan = computed(() => {
    return $settingStore.plans.find(r => {
        return String(r.code).toUpperCase() === String($route.params.code).toUpperCase();
    });
});

const sharePlan = async (article) => {
    // Create new element
    let el = document.createElement('textarea');
    let r = $router.resolve({name: 'user.explore.plan_details', params: {
        code: plan.value.code
    }});
    // Set value (string to be copied)
    el.value = window.location.protocol + '//' + window.location.host + r.fullPath;
    // Set non-editable to avoid focus and move outside of view
    el.setAttribute('readonly', '');
    el.setAttribute('style', {position: 'absolute', left: '-9999px'});
    document.body.appendChild(el);
    // Select text inside element
    el.select();
    // Copy text to clipboard
    document.execCommand('copy');
    // Remove temporary element
    document.body.removeChild(el);

    if (navigator && navigator.share) {
        await navigator.share({
            title: plan.value.plan_name,
            url: r.fullPath,
        });
    }
};
</script>
